import numpy as np
import stan
import arviz as az
import pandas as pd
import pickle

pd.options.display.max_rows = 1000
pd.options.display.max_columns = 1000
 
n_n = [int(v) for v in input('n_n = ').split()]
K = len(n_n)
if K < 3:
    print('Number of categories should be larger than 2.')
    sys.exit()

n_s = [int(v) for v in input('n_s = ').split()]
if len(n_s) != K:
    print('Numbers of categories are not consistent.')
    sys.exit()
s_n = [int(v) for v in input('s_n = ').split()]
if len(s_n) != K:
    print('Numbers of categories are not consistent.')
    sys.exit()
s_s = [int(v) for v in input('s_s = ').split()]
if len(s_s) != K:
    print('Numbers of categories are not consistent.')
    sys.exit()
print('n_n =', n_n)
print('n_s =', n_s)
print('s_n =', s_n)
print('s_s =', s_s)

Data = {'K':K, 'nn_cond':n_n, 'ns_cond':n_s, 'sn_cond':s_n, 'ss_cond':s_s}
with open('SDT_2AFC_KCat_odd.stan' if K % 2 == 1 else
          'SDT_2AFC_KCat_even.stan', 'r') as f:
    sm = stan.build(f.read(), data = Data)

fit = sm.sample(num_samples=10000)
print('fit\n', fit)

inference_data = az.from_pystan(posterior = fit, posterior_model = sm)
smry = az.summary(inference_data)
print('Summary =\n',smry)

with open('i_data.pkl', 'wb') as f:
    pickle.dump(inference_data, f)
print('i_data.pkl was saved.')

df = fit.to_frame()
with open('d_frame.pkl', 'wb') as f:
    pickle.dump(df, f)
print('d_frame.pkl was saved.')
with open('K.pkl', 'wb') as f:
    pickle.dump((K, n_n, n_s, s_n, s_s), f)
print('K.pkl was saved.')

print('\nEnd.\n')
